#include "header.h"
static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";
/*
 *	FILE OUTPUT ROUTINES
 *
 *	lprintf(format,args . . .)		printf to the output buffer
 *	lprcat(string)					append a string to the output buffer
 *	lprint(integer)					send binary integer to output buffer
 *	lprc(character)					append a character to the output buffer
 *	lwrite(buf,len)					write a buffer to the output buffer
 *
 *	FILE INPUT ROUTINES
 *
 *	lgetc()							read one character from input buffer
 *	lrint()							read one integer from input buffer
 *	lrfill(address,number)			put input bytes into a buffer
 *	lgetw()							get a whitespece ended word from input
 *	lgetl()							get a \n or EOF ended line from input
 *
 *	FILE OPEN / CLOSE ROUTINES
 *
 *	lcreat(filename)				create a new file for write
 *	lopen(filename)					open a file for read
 *	lappend(filename)				open for append to an existing file
 *	lrclose()						close the input file
 *	lwclose()						close output file
 *	lflush()						flush the output buffer
 */

static int fd,lfd;							/*  input & output file numbers */
static int ipoint=MAXIBUF,iepoint=MAXIBUF;	/*  input buffering pointers    */
static int wide,left,cont,n,*parg;			/* data for lprintf				*/
static char lgetwbuf[100];

/*
 *	lprintf(format,args . . .)		printf to the output buffer
 */
lprintf(fmt,arg)
	register char *fmt;
	int arg;
    {
	register char *outb,*tmpb;
	char db[12];			/* %d buffer in lprintf	*/
	if (lpnt >= lpend) lflush(); 
	parg = &arg;		outb = lpnt;
	while (1)
		{
		while (*fmt != '%')
			if (*fmt) *outb++ = *fmt++;  else { lpnt=outb;  return; }
		wide = 0;	left = 1;	cont=1;
		while (cont)
		  switch(*(++fmt))
			{
			case 'd':	n = *parg++;
						if (n<0) { n = -n;  *outb++ = '-';  if (wide) --wide; }
						tmpb = db+11;	*tmpb = (char)(n % 10 + '0');
						while (n>9)  *(--tmpb) = (char)((n /= 10) % 10 + '0');
						if (wide==0)  while (tmpb < db+12) *outb++ = *tmpb++;
						else
							{
							wide -= db-tmpb+12;
							if (left)  while (wide-- > 0) *outb++ = ' ';
							while (tmpb < db+12) *outb++ = *tmpb++;
							if (left==0)  while (wide-- > 0) *outb++ = ' ';
							}
						cont=0;	break;

			case 's':	tmpb = (char *)*parg++;
						if (wide==0)  { while (*outb++ = *tmpb++);  --outb; } 
						else
							{
							n = wide - strlen(tmpb);
							if (left)  while (n-- > 0) *outb++ = ' ';
							while (*outb++ = *tmpb++);  --outb;
							if (left==0)  while (n-- > 0) *outb++ = ' ';
							}
						cont=0;	break;

			case 'c':	*outb++ = (char)(*parg++);	cont=0;  break;

			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	wide = 10*wide + *fmt - '0';	break;

			case '-':	left = 0;	break;

			default:	*outb++ = *fmt;  cont=0;	break;
			};
		fmt++;
		}
	}

/*
 *	lprint(integer)					send binary integer to output buffer
 *
 *		+---------+---------+---------+---------+
 *		|	high  |			|		  |	  low	|
 *		|  order  |			|		  |  order	|
 *		|   byte  |			|		  |	  byte	|
 *		+---------+---------+---------+---------+
 *	   31  ---  24 23 --- 16 15 ---  8 7  ---   0
 *
 *		the save order is low order first, to high order (4 bytes total)
 */
lprint(x)
	register int x;
	{
	if (lpnt >= lpend) lflush();
	*lpnt++ =  255 & x;			*lpnt++ =  255 & (x>>8);
	*lpnt++ =  255 & (x>>16);	*lpnt++ =  255 & (x>>24);
	}

#if 0
/*
 *	lprc(character)					append a character to the output buffer
 */
lprc(ch)
	char ch;
    {
	if (lpnt >= lpend) lflush(); 
    *lpnt++ = ch;
    }
#endif 0

/*
 *	lwrite(buf,len)					write a buffer to the output buffer
 */
lwrite(buf,len)
    register char *buf;
    int len;
    {
	register char *str;
	register int num2;
	if (len > 500)  /* dont copy data if can just write it */
		{
		lflush();  write(lfd,buf,len);
#ifdef EXTRA
		c[BYTESOUT] += len;
#endif
		} 
	else
	while (len)
		{
		if (lpnt >= lpend) lflush();	/* if buffer is full flush it	*/
		num2 = lpbuf+BUFBIG-lpnt;	/*	# bytes left in output buffer	*/
		if (num2 > len) num2=len;
		str = lpnt;  len -= num2;
		while (num2--)  *str++ = *buf++;
		lpnt = str;
		}
    }

/*
 *	lgetc()							read one character from input buffer
 *								    returns 0 if EOF
 */
lgetc()
    {
    register int i;
    if (ipoint != iepoint)  return(inbuffer[ipoint++]);
    if (iepoint!=MAXIBUF)   return(0);
    if ((i=read(fd,inbuffer,MAXIBUF))<=0)
        {
        if (i!=0)  write(1,"error reading from input file\n",30);
		iepoint = ipoint = 0;		return(0);
        }
    ipoint=1;  iepoint=i;  return(*inbuffer);
    }

/*
 *	lrint()							read one integer from input buffer
 *
 *		+---------+---------+---------+---------+
 *		|	high  |			|		  |	  low	|
 *		|  order  |			|		  |  order	|
 *		|   byte  |			|		  |	  byte	|
 *		+---------+---------+---------+---------+
 *	   31  ---  24 23 --- 16 15 ---  8 7  ---   0
 *
 *		the save order is low order first, to high order (4 bytes total)
 */
lrint()
	{
	register unsigned i;
	i = 0;
	if (iepoint-ipoint < 4)
		{
		i |= 255 & lgetc();				i |= (255 & lgetc()) << 8;
		i |= (255 & lgetc()) << 16;		i |= (255 & lgetc()) << 24;
		}
	else
		{
		i |= 255 & ((int)inbuffer[ipoint++]);
		i |= (255 & ((int)inbuffer[ipoint++])) << 8;
		i |= (255 & ((int)inbuffer[ipoint++])) << 16;
		i |= (255 & ((int)inbuffer[ipoint++])) << 24;
		}
	return(i);
	}

/*
 *	lrfill(address,number)			put input bytes into a buffer
 */
lrfill(adr,num)
	register char *adr;
	int num;
	{
	register char *pnt;
	register int num2,i;
	while (num)
		{
		if (iepoint == ipoint)
			{
			if (num>5) /* fast way */
				{
				if (read(fd,adr,num) != num)
					write(1,"error reading from input file\n",30);
				num=0;
				}
				else { *adr++ = lgetc();  --num; }
			}
		else
			{
			num2 = iepoint-ipoint;	/*	# of bytes left in the buffer	*/
			if (num2 > num) num2=num;
			pnt = inbuffer+ipoint;	num -= num2;  ipoint += num2;
			while (num2--)  *adr++ = *pnt++;
			}
		}
	}

/*
 *	lgetw()							get a whitespece ended word from input
 */
char *lgetw()
	{
	register char *lgp,cc;
	register int n,quote;
	lgp = lgetwbuf;		n = 39;		cc = 1;  quote=0;
	while ((cc <= 32) && (cc > 0))  cc=lgetc();  /* eat whitespace */
	while (1)
		{
		if (cc != '"') *lgp++ = cc; else quote = 1 & (quote+1);
		if (n-- <= 0) { *lgp=0;  return(lgetwbuf); }
		cc = lgetc();
		if ((cc <= 32) && (quote==0)) { *lgp=0;  return(lgetwbuf); }
		}
	}

/*
 *	function to read in a line ended by newline or EOF
 *	returns pointer to the line
 */
char *lgetl()
	{
	register int i,j;
	register char *str;
	i=99;  str = lgetwbuf;
	while (i-- > 0)
		{
    	if (ipoint != iepoint)  *str = inbuffer[ipoint++];
	    else if (iepoint!=MAXIBUF)   *str = 0;
    	else
			{
			if ((j=read(fd,inbuffer,MAXIBUF))<=0)
        		{
        		if (j!=0)  write(1,"error reading from input file\n",30);
				iepoint = ipoint = 0;		return(0);
        		}
    		ipoint=1;  iepoint=j;  *str = *inbuffer;
			}

		if (*str++ == '\n')
			{
			*str = 0;	return(lgetwbuf);
			}
		}
	*str = 0;	return(lgetwbuf);
	}

/*
 *	lcreat(filename)				create a new file for write
 *									0 means to the terminal
 */
lcreat(str)
	char *str;
	{
	lpnt = lpbuf;	lpend = lpbuf+BUFBIG;
	if (str==0) return(lfd=1);
	if ((lfd=creat(str,0644)) < 0) 
		{
		lfd=1; lprintf("error creating file <%s>\n",str); lflush(); return(-1);
		}
	return(lfd);
	}

/*
 *	lopen(filename)					open a file for read
 *									0 means from the terminal
 */
lopen(str)
	char *str;
	{
	ipoint = iepoint = MAXIBUF;
	if (str==0) return(fd=0);
	if ((fd=open(str,0)) < 0)
		{
		lwclose(); lfd=1; lpnt=lpbuf; return(-1);
		}
	return(fd);
	}

/*
 *	lappend(filename)				open for append to an existing file
 *									0 means to the terminal
 */
lappend(str)
	char *str;
	{
	lpnt = lpbuf;	lpend = lpbuf+BUFBIG;
	if (str==0) return(lfd=1);
	if ((lfd=open(str,2)) < 0)
		{
		lfd=1; return(-1);
		}
	else  lseek(lfd,0,2);
	return(lfd);
	}

/*
 *	lrclose()						close the input file
 */
lrclose()
	{
	if (fd > 0) close(fd);
	}

/*
 *	lwclose()						close output file
 */
lwclose()
	{
	lflush();	if (lfd > 2) close(lfd);
	}

/*
 *	lflush()						flush the output buffer
 */
lflush()
    {
	register int lpoint;
	if ((lpoint = lpnt - lpbuf) > 0)
        {
#ifdef EXTRA
		c[BYTESOUT] += lpoint;
#endif
        if (write(lfd,lpbuf,lpoint) != lpoint)
			write(1,"error writing to output file\n",29);
        }
	lpnt = lpbuf;
    }
