/*	help.c	*/
#include "header.h"
static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";
/*
 *	help function to display the help info	
 *
 *	format of the .larn.help file
 *
 *	1st character of file:	# of pages of help available (ascii digit)
 *	page (23 lines) for the introductory message (not counted in above)
 *	pages of help text (23 lines per page)
 */
extern char helpfile[];
help()
	{
	register int i,j;
	if ((j=openhelp()) < 0)  return;	/* open the help file and get # pages */
	for (i=0; i<23; i++) lgetl();	/* skip over intro message */
	for (;  j>0; j--)
		{
		clear();
		for (i=0; i<23; i++)  lprcat(lgetl());
		if (j>1)
			{
			lprcat("    ---- Press ");  setbold();  lprcat("return");
			resetbold();  lprcat(" to exit, ");  setbold();  lprcat("space");
			resetbold();  lprcat(" for more help ---- ");
			i=0; while ((i!=' ') && (i!='\n') && (i!='\33')) i=getchar();
			if ((i=='\n') || (i=='\33'))
				{
				lrclose();  setscroll();  drawscreen();  return;
				}
			}
		}
	lrclose();  retcont();  drawscreen();
	}

/*
 *	function to display the welcome message and background
 */
welcome()
	{
	register int i;
	if (openhelp() < 0)  return;   	/* open the help file */
	clear();
	for(i=0; i<23; i++)  lprcat(lgetl());
	lrclose();  retcont();	/* press return to continue */
	}

/*
 *	function to say press return to continue and reset scroll when done
 */
retcont()
	{
	cursor(1,24); lprcat("Press "); setbold(); lprcat("return"); resetbold();
	lprcat(" to continue: ");   while (getchar() != '\n');
	setscroll();
	}

/*
 *	routine to open the help file and return the first character - '0'
 */
openhelp()
	{
	if (lopen(helpfile)<0)
		{
		lprcat("Can't open help file \"%s\" ",helpfile);
		sleep(4);	drawscreen();	return(-1);
		}
	resetscroll();  return(lgetc() - '0');
	}

