static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";
#include <sys/types.h>
#include <sys/times.h>
#include <sys/stat.h>
#include "header.h"
extern long int initialtime;
extern int gtime;
static long int zzz;
static struct stat filetimes;
static struct tms cputime;
int outstanding_taxes=0;

struct scofmt			/*	this is the structure for the scoreboard */
	{
	int score;			/* the score of the player */
	short what;			/* the number of the monster that killed player */
	char level;			/* the level player was on when he died */
	char who[40];		/* the name of the character */
	char sciv[26][2];	/* this is the inventory list of the character */
	short suid;			/* the user id number of the player */
	char hardlev;		/* the level of difficulty player played at */
	char order;			/* the relative ordering place of this entry */
	};
struct wscofmt			/*	this is the structure for the winning scoreboard */
	{
	int score;			/* the score of the player */
	short timeused;		/* the time used in mobuls to win the game */
	char who[40];		/* the name of the character */
	short suid;			/* the user id number of the player */
	char hardlev;		/* the level of difficulty player played at */
	char order;			/* the relative ordering place of this entry */
	int taxes;			/* taxes he owes to LRS */
	};

struct log_fmt
	{
	int score;			/* the players score */
	char cavelev;		/* level in caves */
	char diff;			/* difficulty player played at */
	char who[12];		/* player name */
	char what[46];		/* what happened to player */
	int	diedtime;		/* time when game was over */
#ifdef EXTRA
	int elapsedtime;	/* real time of game in seconds */
	int bytout;			/* bytes input and output */
	short bytin;
	short moves;			/* number of moves made by player */
	short ac;			/* armor class of player */
	short hp,hpmax;		/* players hitpoints */
	short cputime;		/* cpu time needed in seconds */
	short killed,spused;/* monsters killed and spells cast */
	short usage;			/* usage of the cpu in % */
	char lev;			/* player level */
#endif
	};

extern char scorefile[],*potionname[],*scrollname[],iven[],ivenarg[],*ckpfile;
extern char logname[],cheat,level,*levelname[],lastmonst[],logfile[];
extern char wizard,ckpflag,loginname[];
extern int c[],srcount,userid;
extern struct monst monster[];
static struct scofmt sco[SCORESIZE];	/* the structure for the scoreboard  */
static struct wscofmt winr[SCORESIZE];	/* struct for the winning scoreboard */
static struct log_fmt logg;				/* structure for the log file 		 */
static char *whydead[] = {
	"quit", "suspended", "self - annialated", "shot by an arrow",
	"hit by a dart", "fell into a pit", "fell into a bottomless pit",
	"a winner", "trapped in solid rock", "killed by a missing save file",
	"killed by an old save file", "caught by the greedy cheater checker trap",
	"killed by a protected save file", "killed his family and committed suicide",
	"erased by a wayward finger", "fell through a bottomless trap door",
	"fell through a trap door", "drank some poisonous water",
	"fried by an electric shock", "slipped on a volcano shaft",
	"killed by a stupid act of frustration", "attacked by a revolting demon",
	"hit by his own magic", "demolished by an unseen attacker",
	"fell into the dreadful sleep", "killed by an exploding chest",
/*26*/	"killed by a missing maze data file", "annialated in a sphere",
	"died a post mortem death","wasted by a malloc() failure"
	};

/*
	function to read in the scoreboard
	returns -1 if unable to read in the scoreboard, returns 0 if all is OK
 */
readboard()
	{
	if (lopen(scorefile)<0)
	  { lcreat(0); lprcat("Can't read scoreboard\n"); lflush(); return(-1);	}
	lrfill(sco,sizeof(sco));		lrfill(winr,sizeof(winr));
	lrclose();  lcreat(0);  return(0);
	}

/*
	function to write out the scoreboard
	returns -1 if unable to write the scoreboard, returns 0 if all is OK
 */
writeboard()
	{
	if (lcreat(scorefile)<0)
	  { lcreat(0); lprcat("Can't write scoreboard\n"); lflush(); return(-1); }
	lwrite(sco,sizeof(sco));		lwrite(winr,sizeof(winr));
	lwclose();  lcreat(0);  return(0);
	}

/*
 *	function to create a new scoreboard
 */
makeboard()
	{
	register int i;
	for (i=0; i<SCORESIZE; i++)
		{ winr[i].taxes = winr[i].score = sco[i].score = 0;  winr[i].order = sco[i].order = i; }
	if (writeboard()==0) chmod(scorefile,0666);
	}

/*
	function to return 1 if player has won a game before 0 otherwise
	also sets c[HARDGAME] to appropriate value
 */
hashewon()
	{
	register int i;
	if (readboard() < 0) makeboard();
	c[HARDGAME] = 0;
	for (i=0; i<SCORESIZE; i++)
		if (winr[i].suid == userid) if (winr[i].score > 0)
			{ c[HARDGAME]=winr[i].hardlev+1;  outstanding_taxes=winr[i].taxes;  return(1); }
	return(0);
	}

/*
	function to pay taxes if any are due
	returns amount actually paid
 */
int paytaxes(x)
	int x;
	{
	register int i,amt;
	if (x<0) return(0);
	readboard();
	for (i=0; i<SCORESIZE; i++)
		if (winr[i].suid == userid)
			if (winr[i].score > 0)
				{
				amt = winr[i].taxes;
				if (x < amt) amt=x;
				winr[i].taxes -= amt;
				outstanding_taxes -= amt;
				writeboard();
				return(amt);
				}
	return(0);
	}

/*
	subroutine to print out the winning scoreboard
	returns the number of players on scoreboard that were shown 
 */
winshou()
	{
	register int i,j,count;
	for (count=j=i=0; i<SCORESIZE; i++) if (winr[i].score!= 0) { j++; break; }
	if (j)
		{
		lprcat("\n  Score    Difficulty   Time Needed   Larn Winners List\n");

		for (i=0; i<SCORESIZE; i++)
			for (j=0; j<SCORESIZE; j++)
				if (winr[j].order == i)
					{
					if (winr[j].score)
						{
						count++;
						lprintf("%8d       %2d       %4d Mobuls   %s \n",
						winr[j].score,winr[j].hardlev,winr[j].timeused,winr[j].who);
						}
					j=SCORESIZE;
					}
		}
	return(count);	/* return number of people on scoreboard */
	}

/*
	subroutine to print out the non-winners scoreboard
	enter with 0 to list the scores, enter with 1 to list inventories too
	returns the number of players on scoreboard that were shown 
 */
shou(x)
	int x;
	{
	register int i,j,n,k;
	int count;
	for (count=j=i=0; i<SCORESIZE; i++) if (sco[i].score!= 0) { j++; break; }
	if (j)
		{
		lprcat("\n   Score   Difficulty   Larn Visitor Log\n");
		for (i=0; i<SCORESIZE; i++)
			for (j=0; j<SCORESIZE; j++)
				if (sco[j].order == i)
					{
					if (sco[j].score)
						{
						count++;
						lprintf("%8d       %2d       %s ",
							sco[j].score,sco[j].hardlev,sco[j].who);
						if (sco[j].what < 256) lprintf("killed by a %s",monster[sco[j].what].name);
							else lprintf("%s",whydead[sco[j].what - 256]);
						if (x != 263) lprintf(" on %s",levelname[sco[j].level]);
						if (x)
							{
							for (n=0; n<26; n++) { iven[n]=sco[j].sciv[n][0]; ivenarg[n]=sco[j].sciv[n][1]; }
							for (k=1; k<70; k++)
							  for (n=0; n<26; n++)
								if (k==iven[n])  { srcount=0; show3(n); }
							lprcat("\n\n");
							}
						else lprc('\n');
						}
					j=SCORESIZE;
					}
		}
	return(count);	/* return the number of players just shown */
	}

/*
	function to show the scoreboard on the terminal
 */
showscores()
	{
	register int i,j;
	lflush();  lcreat(0);  if (readboard()<0) return;
	i=winshou();	j=shou(0);	
	if (i+j==0) lprcat("The scoreboard is empty.\n"); else lprc('\n');
	lflush();
	}

/*
	function to show scores and the iven lists that go with them
 */
showallscores()
	{
	register int i,j;
	lflush();  lcreat(0);  if (readboard()<0) return;
	c[WEAR] = c[WIELD] = c[SHIELD] = -1;  /* not wielding or wearing anything */
	for (i=0; i<MAXPOTION; i++) potionname[i][0]=' ';
	for (i=0; i<MAXSCROLL; i++) scrollname[i][0]=' ';
	i=winshou();  j=shou(1);
	if (i+j==0) lprcat("The scoreboard is empty.\n"); else lprc('\n');
	lflush();
	}

/*
	function to sort the scoreboard
	returns 0 if no sorting done, else returns 1
 */
sortboard()
	{
	register int i,j,jdat,pos;
	for (i=0; i<SCORESIZE; i++) sco[i].order = winr[i].order = -1;
	pos=0;  while (pos < SCORESIZE)
		{
		jdat=0;
		for (i=0; i<SCORESIZE; i++)
			if ((sco[i].order < 0) && (sco[i].score >= jdat))
				{ j=i;  jdat=sco[i].score; }
		sco[j].order = pos++;
		}
	pos=0;  while (pos < SCORESIZE)
		{
		jdat=0;
		for (i=0; i<SCORESIZE; i++)
			if ((winr[i].order < 0) && (winr[i].score >= jdat))
				{ j=i;  jdat=winr[i].score; }
		winr[j].order = pos++;
		}
	return(1);
	}

/*
	function to add an entry to the scoreboard
	ex.		newscore(1000, "player 1", 32, 0);
 */
newscore(score, whoo, whyded, winner)
	int score, winner, whyded;
	char *whoo;
	{
	register int i,taxes;
	if (readboard() < 0) return; 	/*	do the scoreboard	*/
	/* if a winner then delete all non-winning scores */
	if (winner)
		{
		for (i=0; i<SCORESIZE; i++) if (sco[i].suid == userid) sco[i].score=0;
		taxes = score*TAXRATE;
		score += 100000*c[HARDGAME];	/* bonus for winning */
	/* if he has a slot on the winning scoreboard update it if greater score */
		for (i=0; i<SCORESIZE; i++) if (winr[i].suid == userid)
				{ new1sub(score,i,whoo,whyded,taxes); return; }
	/* he had no entry. look for last entry and see if he has a greater score */
		for (i=0; i<SCORESIZE; i++) if (winr[i].order == SCORESIZE-1)
				{ new1sub(score,i,whoo,whyded,taxes); return; }
		}
	else  /* for not winning scoreboard */
		{
	/* if he has a slot on the scoreboard update it if greater score */
		for (i=0; i<SCORESIZE; i++) if (sco[i].suid == userid)
				{ new2sub(score,i,whoo,whyded); return; }
	/* he had no entry. look for last entry and see if he has a greater score */
		for (i=0; i<SCORESIZE; i++) if (sco[i].order == SCORESIZE-1)
				{ new2sub(score,i,whoo,whyded); return; }
		}
	}
/*
	subroutine to put player into a winning scoreboard entry if his score
	is high enough
 */
new1sub(score,i,whoo,whyded,taxes)
	int score,i,whyded,taxes;
	char *whoo;
	{
	winr[i].taxes += taxes;
	if ((score >= winr[i].score) || (c[HARDGAME] > winr[i].hardlev))
		{
		strcpy(winr[i].who,whoo);  		winr[i].score=score;
		winr[i].hardlev=c[HARDGAME];	winr[i].suid=userid;
		winr[i].timeused=gtime/100;
		}
	}

/*
	subroutine to put player into a non-winning scoreboard entry if his score
	is high enough
 */
new2sub(score,i,whoo,whyded)
	int score,i,whyded;
	char *whoo;
	{
	register int j;
	if ((score >= sco[i].score) || (c[HARDGAME] > sco[i].hardlev))
		{
		strcpy(sco[i].who,whoo);  sco[i].score=score;
		sco[i].what=whyded;       sco[i].hardlev=c[HARDGAME];
		sco[i].suid=userid;		  sco[i].level=level;
		for (j=0; j<26; j++)
			{ sco[i].sciv[j][0]=iven[j]; sco[i].sciv[j][1]=ivenarg[j]; }
		}
	}

/*
	died(x)

	subroutine to record who used this program and what his score was
	if x < 0 then dont show scores

		< 256	killed by the monster number
		256		quit
		257		suspended
		258		self - annialated
		259		shot by an arrow
		260		hit by a dart
		261		fell into a pit
		262		fell into a bottomless pit
		263		a winner
		264		trapped in solid rock
		265		killed by a missing save file
		266		killed by an old save file
		267		caught by the greedy cheater checker trap
		268		killed by a protected save file
		269		killed his family and killed himself
		270		erased by a wayward finger
		271		fell through a bottomless trap door
		272		fell through a trap door
		273		drank some poisonous water
		274		fried by an electric shock
		275		slipped on a volcano shaft
		276		killed by a stupid act of frustration
		277		attacked by a revolting demon
		278		hit by his own magic
		279		demolished by an unseen attacker
		280		fell into the dreadful sleep
		281		killed by an exploding chest
		282		killed by a missing maze data file
		283		killed by a sphere of annialation
		284		died a post mortem death
		285		malloc() failure
		300		quick quit -- dont put on scoreboard
 */

static int scorerror;
died(x)
	int x;
	{
	register int i,f,win,g;
	char ch,*mod;
	clearvt100();  lflush();  f=0;
	if (ckpflag) unlink(ckpfile);	/* remove checkpoint file if used */
	if (x<0) { f++; x = -x; }	/* if we are not to display the scores */
	if ((x == 300) || (x == 257))  exit();	/* for quick exit or saved game */
	if (x == 263)  win = 1;  else  win = 0;
	c[GOLD] += c[BANKACCOUNT];   c[BANKACCOUNT] = 0;
		/*	now enter the player at the end of the scoreboard */
	newscore(c[GOLD], logname, x, win);
	diedsub(x);	/* print out the score line */  lflush();

	if ((c[GOLD] > 0)) 	/*	yes, wizards can score */
		{
		if (lappend(logfile)<0)  /* append to file */
			{
			if (lcreat(logfile)<0) /* and cant create new log file */
		    	{
				lcreat(0);
				lprcat("\nCan't open record file:  I can't post your score.\n");
				sncbr();  resetscroll();  lflush();  exit();
				}
			chmod(logfile,0666);
			}
		strcpy(logg.who,loginname);
		logg.score = c[GOLD];		logg.diff = c[HARDGAME];
		if (x < 256)
			{
			ch = *monster[x].name;
			if (ch=='a' || ch=='e' || ch=='i' || ch=='o' || ch=='u')
				mod="an";  else mod="a";
			sprintf(logg.what,"killed by %s %s",mod,monster[x].name);
			}
		else sprintf(logg.what,"%s",whydead[x - 256]);
		logg.cavelev=level;
		time(&zzz);	  /* get cpu time -- write out score info */
		logg.diedtime=zzz;
#ifdef EXTRA
		times(&cputime);  /* get cpu time -- write out score info */
		logg.cputime = i = (cputime.tms_utime + cputime.tms_stime)/60 + c[CPUTIME];
		logg.lev=c[LEVEL];			logg.ac=c[AC];
		logg.hpmax=c[HPMAX];		logg.hp=c[HP];
		logg.elapsedtime=(zzz-initialtime+59)/60;
		logg.usage=(10000*i)/(zzz-initialtime);
		logg.bytin=c[BYTESIN];		logg.bytout=c[BYTESOUT];
		logg.moves=c[MOVESMADE];	logg.spused=c[SPELLSCAST];
		logg.killed=c[MONSTKILLED];
#endif
		lwrite(&logg,sizeof(logg));	 lwclose();

/*	now for the scoreboard maintenance -- not for a suspended game 	*/
		if (x != 257)
			{
			if (sortboard())  scorerror = writeboard();
			}
		}
	if ((x==256) || (x==257) || (f != 0)) exit();
	if (scorerror == 0) showscores();	/* if we updated the scoreboard */
	if (x == 263) mailbill();		exit();
	}

/*
	subroutine to print out the line shown the player when he is killed
 */
diedsub(x)
int x;
	{
	register char ch,*mod;
	lprintf("Score: %d, Diff: %d,  %s ",c[GOLD],c[HARDGAME],logname);
	if (x < 256)
		{
		ch = *monster[x].name;
		if (ch=='a' || ch=='e' || ch=='i' || ch=='o' || ch=='u')
			mod="an";  else mod="a";
		lprintf("killed by %s %s",mod,monster[x].name);
		}
	else lprintf("%s",whydead[x - 256]);
	if (x != 263) lprintf(" on %s\n",levelname[level]);  else lprc('\n');
	}

/*
 *	subroutine to read a log file and print it out in ascii format
 */
diedlog()
	{
	if (lopen(logfile)<0)
		{
		lprintf("Can't locate log file <%s>\n",logfile);
		return;
		}
	lcreat(0);
	while (1)
		{
		logg.score= -1;		lrfill(&logg,sizeof(logg));
		if (logg.score== -1) /* end of file */
			{
			lflush();  return;
			}
		lprintf("Score: %d, Diff: %d,  %s %s on %d\n",logg.score,logg.diff,logg.who,logg.what,logg.cavelev);
#ifdef EXTRA
		if (logg.moves<=0) logg.moves=1;
		lprintf("  Experience Level: %d,  AC: %d,  HP: %d/%d,  Elapsed Time: %d minutes\n",logg.lev,logg.ac,logg.hp,logg.hpmax,logg.elapsedtime);
		lprintf("  CPU time used: %d seconds,  Machine usage: %d.%02d%%\n",logg.cputime,logg.usage/100,logg.usage%100);
		lprintf("  BYTES in: %d, out: %d, moves: %d, deaths: %d, spells cast: %d\n",logg.bytin,logg.bytout,logg.moves,logg.killed,logg.spused);
		lprintf("  out bytes per move: %d,  time per move: %d ms\n",logg.bytout/logg.moves,(logg.cputime*1000)/logg.moves);
#endif
		}
	}
