#include "header.h"
static char copyright[]="Larn is copyrighted 1986 by Noah Morgan.\n";

#ifdef SYSV	/* system III or system V */
#include <termio.h>
#define sgttyb termio
#define stty(_a,_b) ioctl(_a,TCSETA,_b)
#define gtty(_a,_b) ioctl(_a,TCGETA,_b)
static int rawflg = 0;
static char saveeof,saveeol;
#define doraw(_a) if(!rawflg){++rawflg;saveeof=_a.c_cc[VMIN];saveeol=_a.c_cc[VTIME];}\
    _a.c_cc[VMIN]=1;_a.c_cc[VTIME]=1;_a.c_lflag &= ~(ICANON|ECHO|ECHOE|ECHOK|ECHONL)
#define unraw(_a) _a.c_cc[VMIN]=saveeof;_a.c_cc[VTIME]=saveeol;_a.c_lflag |= ICANON|ECHO|ECHOE|ECHOK|ECHONL

#else not SYSV

#ifndef BSD
#define CBREAK RAW		/* V7 has no CBREAK */
#endif

#define doraw(_a) (_a.sg_flags |= CBREAK,_a.sg_flags &= ~ECHO)
#define unraw(_a) (_a.sg_flags &= ~CBREAK,_a.sg_flags |= ECHO)
#include <sgtty.h>
#endif not SYSV

extern unsigned random;
extern int c[],cbak[],score[];
extern long int time();
extern char cheat,level,*ctime(),hard[];
extern char lastmonst[],*getlogin(),*levelname[],wizard;
extern char ivenarg[],iven[],boldon,ckpflag,*ckpfile;
static struct sgttyb ttx;
long int initialtime=0;
static long int zzz=0;
char logname[40]=0;	/*	login name storage field for score report */

/*
	setupvt100()

	subroutine to set up VT100 in correct mode for game

	attributes off	$[0m
	clear screen	$[2J
	scroll region	$[0;20r

 */
setupvt100()
	{
	clear();  setscroll();		scbr(); /* system("stty cbreak -echo"); */
	}

/*
	clearvt100()

	subroutine to clean up the vt100 when the game is over

	scroll region	$[0;24r
	clear screen	$[2J
 */
clearvt100()
	{
	resetscroll();  clear();	sncbr(); /* system("stty -cbreak echo"); */
	}

/*
 *	routine to read in one character
 */
getchar()
	{
	char byt;
	register int i;
	extern int errno;
#ifdef EXTRA
	c[BYTESIN]++;
#endif
	lflush();
	read(0,&byt,1); 
	return(byt);
	}

/*
	function to set cbreak -echo for the terminal
		system("stty cbreak -echo")
 */
scbr()
	{
	gtty(0,&ttx);
	doraw(ttx);
	stty(0,&ttx);
	}

/*
	function to set -cbreak echo for the terminal
		system("stty -cbreak echo")
 */
sncbr()
	{
	gtty(0,&ttx);
	unraw(ttx);
	stty(0,&ttx);
	}

/*
	newgame()

	subroutine to save the initial time
 */
newgame()
	{
	register int i;
	for (i=0; i<100; i++) c[i]=0;
	time(&initialtime);		srand((int)initialtime);
	lcreat(0);	/* open buffering for output to terminal */
	}

